package com.upay.sdk.rz;


import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.config.CustomConfig;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.rz.builder.RzOrderBuilder;
import com.upay.sdk.rz.executer.RzOrderExecuter;
import org.apache.commons.codec.binary.Base64;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * 
 *认证提交
 */
public class RzOrderServlet extends HttpServlet {
	
	private static final long serialVersionUID = -4441309027072756412L;
	static final Logger LOGGER = LoggerFactory.getLogger(RzOrderServlet.class);

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		doPost(req, resp);
	}

	@Override
	protected void doPost(final HttpServletRequest req, final HttpServletResponse resp) throws ServletException, IOException {
		req.setCharacterEncoding("UTF-8");
		String merchantId = req.getParameter("merchantId");
		String partnerId = req.getParameter("partnerId");
		String requestId = req.getParameter("requestId");
		String authType = req.getParameter("authType");
		String name = req.getParameter("name");
		String idCardNum = req.getParameter("idCardNum");
		String bankCardNumber = req.getParameter("bankCardNumber");
		String phoneNumber = req.getParameter("phoneNumber");
		String enterpriseName = req.getParameter("enterpriseName");
		String enterpriseOriginCode = req.getParameter("enterpriseOriginCode");

		RzOrderBuilder builder = new RzOrderBuilder(merchantId);
		builder.setRequestId(requestId)
			   .setAuthType(authType)
			   .setName(name)
			   .setIdCardNum(idCardNum)
			   .setBankCardNumber(bankCardNumber)
			   .setPhoneNumber(phoneNumber)
				.setEnterpriseName(enterpriseName)
				.setEnterpriseOriginCode(enterpriseOriginCode);
		
		final PrintWriter out = resp.getWriter();

/*		//加载sdk配置
		CustomConfig customConfig = new CustomConfig();
		customConfig.annotate();
*/
		RzOrderExecuter executer = new RzOrderExecuter();
		try{
			executer.bothOrder(builder,new ResultListenerAdpater(){
				@Override
				public void success(JSONObject jsonObject) {
					if (jsonObject.get("photo") != null) {
						try {
							String photo = jsonObject.getString("photo");
							if(jsonObject.containsKey("photo")){
								jsonObject.remove("photo");
				            }
							HttpSession session = req.getSession();
							session.setAttribute("rzPhoto", Base64.decodeBase64(photo.getBytes("UTF-8")));
							session.setAttribute("rzResponse", jsonObject);
							resp.sendRedirect("authUserEnhance.jsp");
						} catch (Exception e) {
							out.println("响应异常</br>");
							out.println(e.toString());
						}
					}
					out.println("请求成功</br>");
					out.println(jsonObject);
				}
				
			});
		}
		catch(ResponseException e){
			out.println("响应异常</br>");
			out.println(e.toString());
		}
		catch(HmacVerifyException e){
			out.println("签名验证异常</br>");
			out.println(e.toString());
		}
		catch(RequestException e){
			out.println("请求异常</br>");
			out.println(e.toString());
		}
		catch(UnknownException e){
			out.println("未知异常</br>");
			out.println(e.toString());
		}
	}
}
