package com.upay.sdk.rz;

import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.rz.builder.RzQueryBuilder;
import com.upay.sdk.rz.executer.RzOrderExecuter;
import org.apache.commons.codec.binary.Base64;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * 
 * 认证查询
 */
public class RzQueryServlet extends HttpServlet {
	
	private static final long serialVersionUID = 1368658805414752884L;

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		doPost(req, resp);
	}

	@Override
	protected void doPost(final HttpServletRequest req, final HttpServletResponse resp) throws ServletException, IOException {
		String merchantId = req.getParameter("merchantId");
		String requestId = req.getParameter("requestId");

		RzQueryBuilder builder = new RzQueryBuilder(merchantId);
		builder.setRequestId(requestId);

		final PrintWriter out = resp.getWriter();

		/*		//加载sdk配置
		CustomConfig customConfig = new CustomConfig();
		customConfig.annotate();
*/

		RzOrderExecuter executer = new RzOrderExecuter();

		try{
			executer.bothQuery(builder, new ResultListenerAdpater() {
				@Override
	            public void success(JSONObject jsonObject) {
	            	if (jsonObject.get("photo") != null) {
						try {
							String photo = jsonObject.getString("photo");
							if(jsonObject.containsKey("photo")){
								jsonObject.remove("photo");
				            }
							HttpSession session = req.getSession();
							session.setAttribute("rzPhoto", Base64.decodeBase64(photo.getBytes("UTF-8")));
							session.setAttribute("rzResponse", jsonObject);
							resp.sendRedirect("authUserEnhance.jsp");
						} catch (Exception e) {
							out.println("响应异常</br>");
							out.println(e.toString());
						}
					}
	                out.println("请求成功！<br/>");
	                String result = jsonObject.toJSONString();
	                out.print(result);
	            }
			});
		}
		catch(ResponseException e){
			out.println("响应异常</br>");
			out.println(e.toString());
		}
		catch(HmacVerifyException e){
			out.println("签名验证异常</br>");
			out.println(e.toString());
		}
		catch(RequestException e){
			out.println("请求异常</br>");
			out.println(e.toString());
		}
		catch(UnknownException e){
			out.println("未知异常</br>");
			out.println(e.toString());
		}
	}
}
